// -*- C++ -*- //

#ifndef ALGOBOX_H
#define ALGOBOX_H

class AlgoBox;

#include <all_include.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class AlgoBox : public Gtk::VBox
{
  sigc::signal<void, std::string> signal_maplist_need;  
  
  Gtk::ComboBoxText tabcbt;

protected:
  Gtk::Label * label;
  std::vector<Gtk::ComboBoxText *> nodemapcbts;
  std::vector<Gtk::ComboBoxText *> edgemapcbts;
  
public:
  AlgoBox(){};
  AlgoBox(std::vector<std::string>, std::vector<std::string>, std::vector<std::string>);

  virtual void init(std::vector<std::string>, std::vector<std::string>, std::vector<std::string>);

  sigc::signal<void, std::string> signal_maplist_needed();  
  void emit_tab_change();

  void update_tablist( std::vector< std::string > tl );
  void update_maplist( std::vector< std::string >, std::vector< std::string >);

  void update_cbt( std::vector< std::string > tl, Gtk::ComboBoxText &);
  
  virtual void run();
  
  virtual void build_box();
};
#endif //ALGOBOX_H
